diff --git a/src/backend/replication/logical/launcher.c b/src/backend/replication/logical/launcher.c
new file mode 100644
index 0000000..385260e
--- /dev/null
+++ b/src/backend/replication/logical/launcher.c
@@ -0,0 +1,542 @@
+/*-------------------------------------------------------------------------
+ * launcher.c
+ *	   PostgreSQL logical replication apply launcher process
+ *
+ * Copyright (c) 2012-2016, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/backend/replication/logical/launcher.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "miscadmin.h"
+#include "pgstat.h"
+
+#include "access/heapam.h"
+#include "access/htup.h"
+#include "access/htup_details.h"
+#include "access/xact.h"
+
+#include "catalog/pg_subscription.h"
+
+#include "libpq/pqsignal.h"
+
+#include "postmaster/bgworker.h"
+#include "postmaster/fork_process.h"
+#include "postmaster/postmaster.h"
+
+#include "replication/logicalworker.h"
+#include "replication/subscription.h"
+
+#include "storage/ipc.h"
+#include "storage/proc.h"
+#include "storage/procarray.h"
+#include "storage/procsignal.h"
+
+#include "tcop/tcopprot.h"
+
+#include "utils/memutils.h"
+#include "utils/ps_status.h"
+#include "utils/timeout.h"
+#include "utils/snapmgr.h"
+
+int	max_logical_replication_workers = 4;
+LogicalRepWorker *MyLogicalRepWorker = NULL;
+
+typedef struct LogicalRepCtxStruct
+{
+	/* Supervisor process. */
+	pid_t		launcher_pid;
+
+	/* Background workers. */
+	LogicalRepWorker	workers[FLEXIBLE_ARRAY_MEMBER];
+} LogicalRepCtxStruct;
+
+LogicalRepCtxStruct *LogicalRepCtx;
+
+static LogicalRepWorker *logicalrep_worker_find(Oid subid);
+static void logicalrep_worker_launch(Oid dbid, Oid subid);
+static void logicalrep_worker_stop(LogicalRepWorker *worker);
+static void logicalrep_worker_onexit(int code, Datum arg);
+static void logicalrep_worker_detach(void);
+
+static bool xacthook_do_signal_launcher = false;
+
+/*
+ * Load the list of subscriptions.
+ *
+ * Only the fields interesting for worker start/stop functions are filled for
+ * each subscription.
+ */
+static List *
+get_subscription_list(void)
+{
+	List	   *res = NIL;
+	Relation	rel;
+	HeapScanDesc scan;
+	HeapTuple	tup;
+	MemoryContext resultcxt;
+
+	/* This is the context that we will allocate our output data in */
+	resultcxt = CurrentMemoryContext;
+
+	/*
+	 * Start a transaction so we can access pg_database, and get a snapshot.
+	 * We don't have a use for the snapshot itself, but we're interested in
+	 * the secondary effect that it sets RecentGlobalXmin.  (This is critical
+	 * for anything that reads heap pages, because HOT may decide to prune
+	 * them even if the process doesn't attempt to modify any tuples.)
+	 */
+	StartTransactionCommand();
+	(void) GetTransactionSnapshot();
+
+	rel = heap_open(SubscriptionRelationId, AccessShareLock);
+	scan = heap_beginscan_catalog(rel, 0, NULL);
+
+	while (HeapTupleIsValid(tup = heap_getnext(scan, ForwardScanDirection)))
+	{
+		Form_pg_subscription subform = (Form_pg_subscription) GETSTRUCT(tup);
+		Subscription   *sub;
+		MemoryContext	oldcxt;
+
+		/*
+		 * Allocate our results in the caller's context, not the
+		 * transaction's. We do this inside the loop, and restore the original
+		 * context at the end, so that leaky things like heap_getnext() are
+		 * not called in a potentially long-lived context.
+		 */
+		oldcxt = MemoryContextSwitchTo(resultcxt);
+
+		sub = (Subscription *) palloc(sizeof(Subscription));
+		sub->oid = HeapTupleGetOid(tup);
+		sub->dbid = subform->dbid;
+		sub->enabled = subform->subenabled;
+
+		/* We don't fill fields we are not intereste in. */
+		sub->name = NULL;
+		sub->conninfo = NULL;
+		sub->slotname = NULL;
+		sub->publications = NIL;
+
+		res = lappend(res, sub);
+		MemoryContextSwitchTo(oldcxt);
+	}
+
+	heap_endscan(scan);
+	heap_close(rel, AccessShareLock);
+
+	CommitTransactionCommand();
+
+	return res;
+}
+
+/*
+ * Wait for a background worker to start up and attach to the shmem context.
+ *
+ * This is like WaitForBackgroundWorkerStartup(), except that we wait for
+ * attaching, not just start and we also just exit if postmaster died.
+ */
+static bool
+WaitForReplicationWorkerAttach(LogicalRepWorker *worker,
+							   BackgroundWorkerHandle *handle)
+{
+	BgwHandleStatus status;
+	int			rc;
+
+	for (;;)
+	{
+		pid_t		pid;
+
+		CHECK_FOR_INTERRUPTS();
+
+		status = GetBackgroundWorkerPid(handle, &pid);
+
+		/*
+		 * Worker started and attached to our shmem. This check is safe
+		 * because only laucher ever starts the workers, so nobody can steal
+		 * the worker slot.
+		 */
+		if (status == BGWH_STARTED && worker->proc)
+			return true;
+		/* Worker didn't start or died before attaching to our shmem. */
+		if (status == BGWH_STOPPED)
+			return false;
+
+		/*
+		 * We need timeout because we generaly don't get notified via latch
+		 * about the worker attach.
+		 */
+		rc = WaitLatch(MyLatch,
+					   WL_LATCH_SET | WL_TIMEOUT | WL_POSTMASTER_DEATH, 1000L);
+
+		if (rc & WL_POSTMASTER_DEATH)
+			proc_exit(1);
+
+		ResetLatch(MyLatch);
+	}
+
+	return status;
+}
+
+/*
+ * Walks the workers array and searches for one that matches given
+ * subscription id.
+ */
+static LogicalRepWorker *
+logicalrep_worker_find(Oid subid)
+{
+	int	i;
+	LogicalRepWorker   *res = NULL;
+
+	/* Block concurrent modification. */
+	LWLockAcquire(LogicalRepLauncherLock, LW_SHARED);
+
+	/* Search for attached worker for a given subscription id. */
+	for (i = 0; i < max_logical_replication_workers; i++)
+	{
+		LogicalRepWorker   *w = &LogicalRepCtx->workers[i];
+		if (w->subid == subid && w->proc && IsBackendPid(w->proc->pid))
+		{
+			res = w;
+			break;
+		}
+	}
+
+	LWLockRelease(LogicalRepLauncherLock);
+
+	return res;
+}
+
+/*
+ * Start new apply background worker.
+ */
+static void
+logicalrep_worker_launch(Oid dbid, Oid subid)
+{
+	BackgroundWorker	bgw;
+	BackgroundWorkerHandle *bgw_handle;
+	int					slot;
+	LogicalRepWorker   *worker = NULL;
+
+	ereport(LOG,
+			(errmsg("starting logical replication worker for subscription %u",
+					subid)));
+
+	/*
+	 * We need to do the modification of the shared memory under lock so that
+	 * we have consistent view.
+	 */
+	LWLockAcquire(LogicalRepLauncherLock, LW_EXCLUSIVE);
+
+	/* Find unused worker slot. */
+	for (slot = 0; slot < max_logical_replication_workers; slot++)
+	{
+		if (!LogicalRepCtx->workers[slot].proc)
+		{
+			worker = &LogicalRepCtx->workers[slot];
+			break;
+		}
+	}
+
+	/* Bail if not found */
+	if (worker == NULL)
+	{
+		ereport(WARNING,
+				(errcode(ERRCODE_CONFIGURATION_LIMIT_EXCEEDED),
+				 errmsg("logical replication worker registration failed, "
+						"you might want to increase "
+						"max_logical_replication_workers setting")));
+		return;
+	}
+
+	/* Prepare the worker info. */
+	memset(worker, 0, sizeof(LogicalRepWorker));
+	worker->dbid = dbid;
+	worker->subid = subid;
+
+	LWLockRelease(LogicalRepLauncherLock);
+
+	/* Register the new dynamic worker. */
+	bgw.bgw_flags =	BGWORKER_SHMEM_ACCESS |
+		BGWORKER_BACKEND_DATABASE_CONNECTION;
+	bgw.bgw_start_time = BgWorkerStart_RecoveryFinished;
+	bgw.bgw_main = ApplyWorkerMain;
+
+	bgw.bgw_restart_time = BGW_NEVER_RESTART;
+	bgw.bgw_notify_pid = MyProcPid;
+	bgw.bgw_main_arg = slot;
+
+	if (!RegisterDynamicBackgroundWorker(&bgw, &bgw_handle))
+	{
+		ereport(WARNING,
+				(errcode(ERRCODE_CONFIGURATION_LIMIT_EXCEEDED),
+				 errmsg("logical replication worker registration failed, "
+						"you might want to increase "
+						"max_logical_replication_workers setting")));
+		return;
+	}
+
+	/* Now wait until it attaches. */
+	if (!WaitForReplicationWorkerAttach(worker, bgw_handle))
+	{
+		ereport(WARNING,
+				(errcode(ERRCODE_CONFIGURATION_LIMIT_EXCEEDED),
+				 errmsg("could not launch logical replication worker")));
+		return;
+	}
+}
+
+/*
+ * Stop the logical replication worker and wait until it detaches from the
+ * slot.
+ */
+static void
+logicalrep_worker_stop(LogicalRepWorker *worker)
+{
+	LWLockAcquire(LogicalRepLauncherLock, LW_EXCLUSIVE);
+
+	/* Check that the worker is up and what we expect. */
+	if (!worker->proc)
+		return;
+	if (!IsBackendPid(worker->proc->pid))
+		return;
+
+	/* Terminate the worker. */
+	kill(worker->proc->pid, SIGTERM);
+
+	LWLockRelease(LogicalRepLauncherLock);
+
+	/* Wait for it to detach. */
+	for (;;)
+	{
+		int	rc = WaitLatch(&MyProc->procLatch,
+						   WL_LATCH_SET | WL_TIMEOUT | WL_POSTMASTER_DEATH,
+						   1000L);
+
+        /* emergency bailout if postmaster has died */
+        if (rc & WL_POSTMASTER_DEATH)
+			proc_exit(1);
+
+        ResetLatch(&MyProc->procLatch);
+
+		CHECK_FOR_INTERRUPTS();
+
+		if (!worker->proc)
+			return;
+	}
+}
+
+/*
+ * Attach to a slot.
+ */
+void
+logicalrep_worker_attach(int slot)
+{
+	/* Block concurrent access. */
+	LWLockAcquire(LogicalRepLauncherLock, LW_EXCLUSIVE);
+
+	Assert(slot >= 0 && slot < max_logical_replication_workers);
+	MyLogicalRepWorker = &LogicalRepCtx->workers[slot];
+
+	if (MyLogicalRepWorker->proc)
+		ereport(ERROR,
+			   (errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				errmsg("logical replication worker slot %d already used by "
+					   "another worker", slot)));
+
+	MyLogicalRepWorker->proc = MyProc;
+	before_shmem_exit(logicalrep_worker_onexit, (Datum) 0);
+
+	LWLockRelease(LogicalRepLauncherLock);
+}
+
+/*
+ * Detach the worker (cleans up the worker info).
+ */
+static void
+logicalrep_worker_detach(void)
+{
+	/* Block concurrent access. */
+	LWLockAcquire(LogicalRepLauncherLock, LW_EXCLUSIVE);
+
+	MyLogicalRepWorker->dbid = InvalidOid;
+	MyLogicalRepWorker->subid = InvalidOid;
+	MyLogicalRepWorker->proc = NULL;
+
+	LWLockRelease(LogicalRepLauncherLock);
+}
+
+/*
+ * Cleanup function.
+ *
+ * Called on logical replication worker exit.
+ */
+static void
+logicalrep_worker_onexit(int code, Datum arg)
+{
+	logicalrep_worker_detach();
+}
+
+/*
+ * ApplyLauncherShmemSize
+ *		Compute space needed for replication launcher shared memory
+ */
+Size
+ApplyLauncherShmemSize(void)
+{
+	Size		size;
+
+	/*
+	 * Need the fixed struct and the array of LogicalRepWorker.
+	 */
+	size = sizeof(LogicalRepCtxStruct);
+	size = MAXALIGN(size);
+	size = add_size(size, mul_size(max_logical_replication_workers,
+								   sizeof(LogicalRepWorker)));
+	return size;
+}
+
+/*
+ * ApplyLauncherShmemInit
+ *		Allocate and initialize replication launcher shared memory
+ */
+void
+ApplyLauncherShmemInit(void)
+{
+	bool		found;
+
+	LogicalRepCtx = (LogicalRepCtxStruct *)
+		ShmemInitStruct("Logical Replication Launcher Data",
+						ApplyLauncherShmemSize(),
+						&found);
+
+	if (IsUnderPostmaster)
+	{
+		Assert(found);
+		return;
+	}
+
+	memset(LogicalRepCtx, 0, ApplyLauncherShmemSize());
+}
+
+static void
+xacthook_signal_launcher(XactEvent event, void *arg)
+{
+	switch (event)
+	{
+		case XACT_EVENT_COMMIT:
+			if (xacthook_do_signal_launcher)
+				ApplyLauncherWakeup();
+			break;
+		default:
+			/* We're not interested in other tx events */
+			break;
+	}
+}
+
+void
+ApplyLauncherWakeupOnCommit(void)
+{
+	if (!xacthook_do_signal_launcher)
+	{
+		RegisterXactCallback(xacthook_signal_launcher, NULL);
+		xacthook_do_signal_launcher = true;
+	}
+}
+
+void
+ApplyLauncherWakeup(void)
+{
+	if (IsBackendPid(LogicalRepCtx->launcher_pid))
+		kill(LogicalRepCtx->launcher_pid, SIGUSR1);
+}
+
+/*
+ * Main loop for the apply launcher process.
+ */
+void
+ApplyLauncherMain(Datum main_arg)
+{
+	ereport(LOG,
+			(errmsg("logical replication launcher started")));
+
+	/* Establish signal handlers. */
+	pqsignal(SIGTERM, die);
+	BackgroundWorkerUnblockSignals();
+
+	/* Make it easy to identify our processes. */
+	SetConfigOption("application_name", MyBgworkerEntry->bgw_name,
+					PGC_USERSET, PGC_S_SESSION);
+
+	LogicalRepCtx->launcher_pid = MyProcPid;
+
+	/*
+	 * Establish connection to nailed catalogs (we only ever access
+	 * pg_subscription).
+	 */
+	BackgroundWorkerInitializeConnection(NULL, NULL);
+
+	/* Enter main loop */
+	for (;;)
+    {
+		int			rc;
+		List	   *sublist;
+		ListCell   *lc;
+		Subscription   *startsub = NULL;
+		MemoryContext	subctx;
+		MemoryContext	oldctx;
+
+		CHECK_FOR_INTERRUPTS();
+
+		/* Use temporary context for the database list and worker info. */
+		subctx = AllocSetContextCreate(TopMemoryContext,
+									   "Logical Replication Launcher sublist",
+									   ALLOCSET_DEFAULT_MINSIZE,
+									   ALLOCSET_DEFAULT_INITSIZE,
+									   ALLOCSET_DEFAULT_MAXSIZE);
+		oldctx = MemoryContextSwitchTo(subctx);
+
+		/* Search for subscriptions to start or stop. */
+		sublist = get_subscription_list();
+		foreach(lc, sublist)
+		{
+			Subscription	   *sub = (Subscription *) lfirst(lc);
+			LogicalRepWorker   *w = logicalrep_worker_find(sub->oid);
+
+			if (sub->enabled && w == NULL && startsub == NULL)
+				startsub = sub;
+			else if (!sub->enabled && w != NULL)
+				logicalrep_worker_stop(w);
+		}
+
+		if (startsub)
+			logicalrep_worker_launch(startsub->dbid, startsub->oid);
+
+		/* Switch back to original memory context. */
+		MemoryContextSwitchTo(oldctx);
+		/* Clean the temporary memory. */
+		MemoryContextDelete(subctx);
+
+		/* Wait for more work. */
+		rc = WaitLatch(&MyProc->procLatch,
+					   WL_LATCH_SET | WL_TIMEOUT | WL_POSTMASTER_DEATH,
+					   startsub ? 5000L : 180000L);
+
+        /* emergency bailout if postmaster has died */
+        if (rc & WL_POSTMASTER_DEATH)
+			proc_exit(1);
+
+		ResetLatch(&MyProc->procLatch);
+	}
+
+	LogicalRepCtx->launcher_pid = 0;
+
+	/* ... and if it returns, we're done */
+	ereport(LOG,
+			(errmsg("logical replication launcher shutting down")));
+
+	proc_exit(0);
+}
diff --git a/src/backend/storage/ipc/ipci.c b/src/backend/storage/ipc/ipci.c
index c04b17f..423cb0f 100644
--- a/src/backend/storage/ipc/ipci.c
+++ b/src/backend/storage/ipc/ipci.c
@@ -28,6 +28,7 @@
 #include "postmaster/bgworker_internals.h"
 #include "postmaster/bgwriter.h"
 #include "postmaster/postmaster.h"
+#include "replication/logicalworker.h"
 #include "replication/slot.h"
 #include "replication/walreceiver.h"
 #include "replication/walsender.h"
@@ -137,6 +138,7 @@ CreateSharedMemoryAndSemaphores(bool makePrivate, int port)
 		size = add_size(size, ReplicationOriginShmemSize());
 		size = add_size(size, WalSndShmemSize());
 		size = add_size(size, WalRcvShmemSize());
+		size = add_size(size, ApplyLauncherShmemSize());
 		size = add_size(size, SnapMgrShmemSize());
 		size = add_size(size, BTreeShmemSize());
 		size = add_size(size, SyncScanShmemSize());
@@ -245,6 +247,7 @@ CreateSharedMemoryAndSemaphores(bool makePrivate, int port)
 	ReplicationOriginShmemInit();
 	WalSndShmemInit();
 	WalRcvShmemInit();
+	ApplyLauncherShmemInit();
 
 	/*
 	 * Set up other modules that need some shared memory space
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index 9c93df0..32856db 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -58,6 +58,7 @@
 #include "postmaster/postmaster.h"
 #include "postmaster/syslogger.h"
 #include "postmaster/walwriter.h"
+#include "replication/logicalworker.h"
 #include "replication/slot.h"
 #include "replication/syncrep.h"
 #include "replication/walreceiver.h"
@@ -171,6 +172,7 @@ static const char *show_tcp_keepalives_interval(void);
 static const char *show_tcp_keepalives_count(void);
 static bool check_maxconnections(int *newval, void **extra, GucSource source);
 static bool check_max_worker_processes(int *newval, void **extra, GucSource source);
+static bool check_max_logical_replication_workers(int *newval, void **extra, GucSource source);
 static bool check_autovacuum_max_workers(int *newval, void **extra, GucSource source);
 static bool check_autovacuum_work_mem(int *newval, void **extra, GucSource source);
 static bool check_effective_io_concurrency(int *newval, void **extra, GucSource source);
@@ -2474,6 +2476,18 @@ static struct config_int ConfigureNamesInt[] =
 	},
 
 	{
+		{"max_logical_replication_processes",
+			PGC_POSTMASTER,
+			RESOURCES_ASYNCHRONOUS,
+			gettext_noop("Maximum number of logical replication worker processes."),
+			NULL,
+		},
+		&max_logical_replication_workers,
+		4, 1, MAX_BACKENDS,
+		check_max_logical_replication_workers, NULL, NULL
+	},
+
+	{
 		{"log_rotation_age", PGC_SIGHUP, LOGGING_WHERE,
 			gettext_noop("Automatic log file rotation will occur after N minutes."),
 			NULL,
@@ -10184,6 +10198,14 @@ check_max_worker_processes(int *newval, void **extra, GucSource source)
 }
 
 static bool
+check_max_logical_replication_workers(int *newval, void **extra, GucSource source)
+{
+	if (*newval > max_worker_processes)
+		return false;
+	return true;
+}
+
+static bool
 check_effective_io_concurrency(int *newval, void **extra, GucSource source)
 {
 #ifdef USE_PREFETCH
diff --git a/src/include/executor/nodeModifyTable.h b/src/include/executor/nodeModifyTable.h
index 6b66353..dfb7e7c 100644
--- a/src/include/executor/nodeModifyTable.h
+++ b/src/include/executor/nodeModifyTable.h
@@ -19,5 +19,25 @@ extern ModifyTableState *ExecInitModifyTable(ModifyTable *node, EState *estate,
 extern TupleTableSlot *ExecModifyTable(ModifyTableState *node);
 extern void ExecEndModifyTable(ModifyTableState *node);
 extern void ExecReScanModifyTable(ModifyTableState *node);
+extern TupleTableSlot *ExecInsert(ModifyTableState *mtstate,
+		   TupleTableSlot *slot,
+		   TupleTableSlot *planSlot,
+		   List *arbiterIndexes,
+		   OnConflictAction onconflict,
+		   EState *estate,
+		   bool canSetTag);
+extern TupleTableSlot *ExecDelete(ItemPointer tupleid,
+		   HeapTuple oldtuple,
+		   TupleTableSlot *planSlot,
+		   EPQState *epqstate,
+		   EState *estate,
+		   bool canSetTag);
+extern TupleTableSlot *ExecUpdate(ItemPointer tupleid,
+		   HeapTuple oldtuple,
+		   TupleTableSlot *slot,
+		   TupleTableSlot *planSlot,
+		   EPQState *epqstate,
+		   EState *estate,
+		   bool canSetTag);
 
 #endif   /* NODEMODIFYTABLE_H */
diff --git a/src/include/postmaster/bgworker_internals.h b/src/include/postmaster/bgworker_internals.h
index cd6cd44..3f8e764 100644
--- a/src/include/postmaster/bgworker_internals.h
+++ b/src/include/postmaster/bgworker_internals.h
@@ -52,4 +52,6 @@ extern void StartBackgroundWorker(void) pg_attribute_noreturn();
 extern BackgroundWorker *BackgroundWorkerEntry(int slotno);
 #endif
 
+extern bool internal_bgworker_registration_in_progress;
+
 #endif   /* BGWORKER_INTERNALS_H */
diff --git a/src/include/replication/logicalworker.h b/src/include/replication/logicalworker.h
new file mode 100644
index 0000000..64f36d3
--- /dev/null
+++ b/src/include/replication/logicalworker.h
@@ -0,0 +1,41 @@
+/*-------------------------------------------------------------------------
+ *
+ * logicalworker.h
+ *	  Exports for logical replication workers.
+ *
+ * Portions Copyright (c) 2010-2016, PostgreSQL Global Development Group
+ *
+ * src/include/replication/logicalworker.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef LOGICALWORKER_H
+#define LOGICALWORKER_H
+
+typedef struct LogicalRepWorker
+{
+	/* Pointer to proc array. NULL if not running. */
+	PGPROC *proc;
+
+	/* Database id to connect to. */
+	Oid		dbid;
+
+	/* Subscription id for the worker. */
+	Oid		subid;
+} LogicalRepWorker;
+
+extern int max_logical_replication_workers;
+extern LogicalRepWorker *MyLogicalRepWorker;
+
+extern void ApplyLauncherMain(Datum main_arg);
+extern void ApplyWorkerMain(Datum main_arg);
+
+extern Size ApplyLauncherShmemSize(void);
+extern void ApplyLauncherShmemInit(void);
+
+extern void ApplyLauncherWakeupOnCommit(void);
+extern void ApplyLauncherWakeup(void);
+
+extern void logicalrep_worker_attach(int slot);
+
+#endif   /* LOGICALWORKER_H */
diff --git a/src/include/replication/walreceiver.h b/src/include/replication/walreceiver.h
index 0f42008..3801949 100644
--- a/src/include/replication/walreceiver.h
+++ b/src/include/replication/walreceiver.h
@@ -152,6 +152,9 @@ typedef char *(*walrcvconn_create_slot_fn) (
 									WalReceiverConnHandle *handle,
 									char *slotname, bool logical,
 									XLogRecPtr *lsn);
+typedef void (*walrcvconn_drop_slot_fn) (
+									WalReceiverConnHandle *handle,
+									char *slotname);
 typedef bool (*walrcvconn_startstreaming_physical_fn) (
 									WalReceiverConnHandle *handle,
 									TimeLineID tli, XLogRecPtr startpoint,
@@ -174,6 +177,7 @@ typedef struct WalReceiverConnAPI {
 	walrcvconn_identify_system_fn			identify_system;
 	walrcvconn_readtimelinehistoryfile_fn	readtimelinehistoryfile;
 	walrcvconn_create_slot_fn				create_slot;
+	walrcvconn_drop_slot_fn					drop_slot;
 	walrcvconn_startstreaming_physical_fn	startstreaming_physical;
 	walrcvconn_startstreaming_logical_fn	startstreaming_logical;
 	walrcvconn_endstreaming_fn				endstreaming;
diff --git a/src/test/perl/PostgresNode.pm b/src/test/perl/PostgresNode.pm
index e629373..408a2c1 100644
--- a/src/test/perl/PostgresNode.pm
+++ b/src/test/perl/PostgresNode.pm
@@ -407,8 +407,16 @@ sub init
 
 	if ($params{allows_streaming})
 	{
-		print $conf "wal_level = replica\n";
+		if ($params{allows_streaming} eq "logical")
+		{
+			print $conf "wal_level = logical\n";
+		}
+		else
+		{
+			print $conf "wal_level = replica\n";
+		}
 		print $conf "max_wal_senders = 5\n";
+		print $conf "max_replication_slots = 5\n";
 		print $conf "wal_keep_segments = 20\n";
 		print $conf "max_wal_size = 128MB\n";
 		print $conf "shared_buffers = 1MB\n";
diff --git a/src/test/subscription/Makefile b/src/test/subscription/Makefile
new file mode 100644
index 0000000..54c4d19
--- /dev/null
+++ b/src/test/subscription/Makefile
@@ -0,0 +1,20 @@
+#-------------------------------------------------------------------------
+#
+# Makefile for src/test/subscription
+#
+# Portions Copyright (c) 1996-2016, PostgreSQL Global Development Group
+# Portions Copyright (c) 1994, Regents of the University of California
+#
+# src/test/subscription/Makefile
+#
+#-------------------------------------------------------------------------
+
+subdir = src/test/subscription
+top_builddir = ../../..
+include $(top_builddir)/src/Makefile.global
+
+check:
+	$(prove_check)
+
+clean distclean maintainer-clean:
+	rm -rf tmp_check
diff --git a/src/test/subscription/README b/src/test/subscription/README
new file mode 100644
index 0000000..e9e9375
--- /dev/null
+++ b/src/test/subscription/README
@@ -0,0 +1,16 @@
+src/test/subscription/README
+
+Regression tests for subscription/logical replication
+=====================================================
+
+This directory contains a test suite for subscription/logical replication.
+
+Running the tests
+=================
+
+    make check
+
+NOTE: This creates a temporary installation, and some tests may
+create one or multiple nodes, for the purpose of the tests.
+
+NOTE: This requires the --enable-tap-tests argument to configure.
diff --git a/src/test/subscription/t/001_rep_changes.pl b/src/test/subscription/t/001_rep_changes.pl
new file mode 100644
index 0000000..dca19c4
--- /dev/null
+++ b/src/test/subscription/t/001_rep_changes.pl
@@ -0,0 +1,89 @@
+# Basic logical replication test
+use strict;
+use warnings;
+use PostgresNode;
+use TestLib;
+use Test::More tests => 3;
+
+# Initialize provider node
+my $node_provider = get_new_node('provider');
+$node_provider->init(allows_streaming => 'logical');
+$node_provider->start;
+
+# Create subscriber node
+my $node_subscriber = get_new_node('subscriber');
+$node_subscriber->init(allows_streaming => 'logical');
+$node_subscriber->start;
+
+# Create some preexisting content on provider
+$node_provider->safe_psql('postgres',
+	"CREATE TABLE tab_notrep AS SELECT generate_series(1,10) AS a");
+$node_provider->safe_psql('postgres',
+	"CREATE TABLE tab_ins (a int)");
+$node_provider->safe_psql('postgres',
+	"CREATE TABLE tab_rep (a int primary key)");
+
+# Setup structure on subscriber
+$node_subscriber->safe_psql('postgres',
+	"CREATE TABLE tab_notrep (a int)");
+$node_subscriber->safe_psql('postgres',
+	"CREATE TABLE tab_ins (a int)");
+$node_subscriber->safe_psql('postgres',
+	"CREATE TABLE tab_rep (a int primary key)");
+
+# Setup logical replication
+my $provider_connstr = $node_provider->connstr . ' dbname=postgres';
+$node_provider->safe_psql('postgres',
+	"CREATE PUBLICATION tap_pub");
+$node_provider->safe_psql('postgres',
+	"CREATE PUBLICATION tap_pub_ins_only WITH noreplicate_delete noreplicate_update");
+$node_provider->safe_psql('postgres',
+	"ALTER PUBLICATION tap_pub ADD TABLE tab_rep");
+$node_provider->safe_psql('postgres',
+	"ALTER PUBLICATION tap_pub_ins_only ADD TABLE tab_ins");
+
+$node_subscriber->safe_psql('postgres',
+	"CREATE SUBSCRIPTION tap_sub WITH CONNECTION '$provider_connstr' PUBLICATION tap_pub, tap_pub_ins_only");
+
+# Wait for subscriber to finish table sync
+my $appname = 'tap_sub';
+my $caughtup_query =
+"SELECT pg_current_xlog_location() <= write_location FROM pg_stat_replication WHERE application_name = '$appname';";
+$node_provider->poll_query_until('postgres', $caughtup_query)
+  or die "Timed out while waiting for subscriber to catch up";
+
+my $result =
+  $node_subscriber->safe_psql('postgres', "SELECT count(*) FROM tab_notrep");
+print "node_subscriber: $result\n";
+is($result, qq(0), 'check non-replicated table is empty on subscriber');
+
+
+$node_provider->safe_psql('postgres',
+	"INSERT INTO tab_ins SELECT generate_series(1,50)");
+$node_provider->safe_psql('postgres',
+	"DELETE FROM tab_ins WHERE a > 20");
+$node_provider->safe_psql('postgres',
+	"UPDATE tab_ins SET a = -a");
+
+$node_provider->safe_psql('postgres',
+	"INSERT INTO tab_rep SELECT generate_series(1,50)");
+$node_provider->safe_psql('postgres',
+	"DELETE FROM tab_rep WHERE a > 20");
+$node_provider->safe_psql('postgres',
+	"UPDATE tab_rep SET a = -a");
+
+$node_provider->poll_query_until('postgres', $caughtup_query)
+  or die "Timed out while waiting for subscriber to catch up";
+
+$result =
+  $node_subscriber->safe_psql('postgres', "SELECT count(*), min(a), max(a) FROM tab_ins");
+print "node_subscriber: $result\n";
+is($result, qq(50|1|50), 'check replicated inserts on subscriber');
+
+$result =
+  $node_subscriber->safe_psql('postgres', "SELECT count(*), min(a), max(a) FROM tab_rep");
+print "node_subscriber: $result\n";
+is($result, qq(20|-20|-1), 'check replicated changes on subscriber');
+
+$node_subscriber->stop('fast');
+$node_provider->stop('fast');
